<?PHP
/////////////////////////////////////////////////////////////
//	search.php
/////////////////////////////////////////////////////////////
//
//	収蔵品検索ツール
//
//  説明：収蔵品ＤＢ検索
//  作成者：Takao Yoshimitsu
//  作成日：20031230
//  更新日：20070501 分類番号2削除
//  更新日：20160524 データアクセスをPDOに変更
//  REVISIONS: 0.9
//
//	(C) COPYRIGHT 2004-2016 Sue Museum & Museum Project
//////////////////////////////////////////////////////////////

$nDispListNo = 20;	//検索結果表示ＭＡＸ数

//////////////////////////////////////////////////////////////
// 変数定義＆初期化
	$hyoujunmei			= NULL;
	$chihoumei			= NULL;
	$yakumei			= NULL;
	$yomi1				= NULL;
	$yomi2				= NULL;
	$syuuzou_no			= NULL;
	$syuuzou_basyo		= NULL;
	$bunnya1			= NULL;
	$bunnya2			= NULL;
	$grouping			= NULL;
	$bunrui_no			= NULL;
	$nRec_count			= NULL;
	$gensiryou_no		= NULL;
	$page				= 0;


//////////////////////////////////////////////////////////////
//
// 説明：収蔵品ＤＢ検索
// 機能説明：ＤＢから検索条件にヒットしたものを表示する
// 引数：
//string $schType				検索のタイプ
//string $hyoujunmei			標準名
//string $chihoumei				地方名
//string $yakumei				訳名
//string $yomi1					読み
//string $yomi2					読み２
//string $syuuzou_no			収蔵番号
//string $syuuzou_basyo			収蔵場所
//string $bunnya1				分野
//string $bunnya2				分野2
//string $grouping				グルーピング
//int	 nPage					(I)表示開始ページ（１～）
//int	 &$nRec_count			(O)全レコード数
//  戻り値：
//        配列で最大２０(nDispListNo)レコード
//////////////////////////////////////////////////////////////
function sch_db($schType="keyword", 
				$hyoujunmei=NULL, 
				$bunnya1=NULL, 
				$grouping=NULL, 
				$nPage=NULL, 
				&$rec_count) {

	global $dbUser;
	global $dbPass;
	global $dbHost;
	global $dbName;
	global $dbType;
	global $dbErrorMessage;
	global $nDispListNo;
	global $debugflag;

	if ($nPage <= 0) {
		$dbErrorMessage = "ページ数エラー";
		return FALSE;
	}
	$start = ($nPage - 1)*$nDispListNo;

	$dsn = "$dbType:dbname=$dbName;host=$dbHost;charset=utf8;";
	try {
		$db = new PDO($dsn, $dbUser, $dbPass);
		$db->query('SET NAMES utf8');

		$sqlcnt  = "SELECT COUNT(*) FROM siryoudaityou ";
		$sql     = "SELECT * FROM siryoudaityou ";
		$sqlsort = "ORDER BY syuuzou_no ASC LIMIT ".$start.", ".$nDispListNo;	// ソート&表示用の切り出し
		$sqlc    = "";
		if ($debugflag) {
			print "<font color=red> schType=$schType</font><BR>";
			print "<font color=red> hyoujunmei=$hyoujunmei</font><BR>";
			print "<font color=red> bunnya1=$bunnya1</font><BR>";
			print "<font color=red> grouping=$grouping</font><BR>";
			print "<font color=red> nPage=$nPage</font><BR>";
		}
		if ($schType == "keyword") {
			if ($hyoujunmei !="") {

				$sqlc ="WHERE (hyoujunmei LIKE ? OR chihoumei LIKE ? OR yakumei LIKE ? OR ".
				"yomi1 LIKE ? OR yomi2 LIKE ? OR syuuzou_no LIKE ? OR syuuzou_basyo LIKE ?) AND syuuzou_no!='' ";
				$stmt1 = $db->prepare($sqlcnt.$sqlc);

				$tmpstr = "%".$hyoujunmei."%";
				$stmt1->bindParam(1, $tmpstr);	// hyoujunmei
				$stmt1->bindParam(2, $tmpstr);	// chihoumei
				$stmt1->bindParam(3, $tmpstr);	// yakumei
				$stmt1->bindParam(4, $tmpstr);	// yomi1
				$stmt1->bindParam(5, $tmpstr);	// yomi2
				$stmt1->bindParam(6, $tmpstr);	// syuuzou_no
				$stmt1->bindParam(7, $tmpstr);	// syuuzou_basyo

				$stmt2 = $db->prepare($sql.$sqlc.$sqlsort);
				$stmt2->bindParam(1, $tmpstr);	// hyoujunmei
				$stmt2->bindParam(2, $tmpstr);	// chihoumei
				$stmt2->bindParam(3, $tmpstr);	// yakumei
				$stmt2->bindParam(4, $tmpstr);	// yomi1
				$stmt2->bindParam(5, $tmpstr);	// yomi2
				$stmt2->bindParam(6, $tmpstr);	// syuuzou_no
				$stmt2->bindParam(7, $tmpstr);	// syuuzou_basyo
			}
		}
		else if ($schType == "category") {
			if ($bunnya1 !="") {
				$sqlc ="WHERE (bunnya1 LIKE ? OR bunnya2 LIKE ?) AND syuuzou_no!='' ";
				$stmt1 = $db->prepare($sqlcnt.$sqlc);

				$tmpstr = $bunnya1."%";
				$stmt1->bindParam(1, $tmpstr);	// bunnya1
				$stmt1->bindParam(2, $tmpstr);	// bunnya2

				$stmt2 = $db->prepare($sql.$sqlc.$sqlsort);
				$stmt2->bindParam(1, $tmpstr);
				$stmt2->bindParam(2, $tmpstr);

			}
		}
		else if ($schType == "group") {
			if ($grouping !="") {
				$sqlc ="WHERE (grouping LIKE ?) AND syuuzou_no!='' ";
				$stmt1 = $db->prepare($sqlcnt.$sqlc);
				$tmpstr = $grouping."%";
				$stmt1->bindParam(1, $tmpstr);

				$stmt2 = $db->prepare($sql.$sqlc.$sqlsort);
				$stmt2->bindParam(1, $tmpstr);
			}
		}
		if ($sqlc == "") { //検索条件なしは全件検索
			$sqlc = "WHERE syuuzou_no != '' ";	// 収蔵番号が無いものは表示しない
			$stmt1 = $db->prepare($sqlcnt.$sqlc);
			$stmt2 = $db->prepare($sql.$sqlc.$sqlsort);
		}
		if ($debugflag) {
			print "<font color=red> sqlcnt=$sqlcnt.$sqlc</font><BR>";	// テスト
			print "<font color=red> sql   =$sql.$sqlc.$sqlsort</font><BR>";	// テスト
		}

		if ($stmt1->execute() === FALSE) {
			if ($debugflag) {
				print "<font color=red> stmt1->execute() === FALSE</font><BR>";
			}
		}

		// 件数カウント
		$rec_count = $stmt1->fetchColumn();
		if ($debugflag) {
			print "検索全件数 ".$rec_count."<BR>";	// テスト
			if ($rec_count == FALSE) {
				print "rec_count == FALSE<BR>";
			}
		}
		// ヒットしていなかったら終わり
		if ($rec_count == 0) {
			$dbErrorMessage = "検索にヒットするものがありません。<BR>指定を変えて検索し直してください。<BR>";
			$db = null;
			return FALSE;
		}

		// ソート&表示用の切り出し
		if ($stmt2->execute() === FALSE) {
			if ($debugflag) {
				print "<font color=red> stmt1->execute = FALSE</font><BR>";	// テスト
			}
		}

		$i = 0;
		while ($row = $stmt2->fetch(PDO::FETCH_ASSOC)) {
			$retarry[$i] = $row;
			$i++;
		}

		$db = null;
		return $retarry;

	} catch (PDOException $e) {
    	print "エラー!: " . $e->getMessage() . "<br/>";
	}
}


//////////////////////////////////////////////////////////////
// 説明：収蔵品ＤＢ検索
// 機能説明：ＤＢから原資料番号のものを読み出す
// 引数：
//string $gensiryou_no		(I)検索条件 原資料番号
// 未使用
//////////////////////////////////////////////////////////////
function sch_one_db($gensiryou_no) {

	global $dbUser;
	global $dbPass;
	global $dbHost;
	global $dbName;
	global $dbType;
	global $dbErrorMessage;
	global $nDispListNo;
	global $debugflag;

	$dsn = "$dbType:dbname=$dbName;host=$dbHost;charset=utf8;";
	try {
		$db = new PDO($dsn, $dbUser, $dbPass);
		$db->query('SET NAMES utf8');

		$low  = $gensiryou_no - 0.0005;
		$high = $gensiryou_no + 0.0005;

		// syuzoudaityouから
		$sql = "SELECT * FROM siryoudaityou WHERE $low < gensiryou_no AND gensiryou_no < $high";
		$result = $db->query($sql);
		if ($debugflag) {
			print "<font color=red> sql=$sql</font><BR>";	// テスト
		}

		$row = $result->fetch(PDO::FETCH_ASSOC);
		if ($debugflag) {
			print "<font color=red> gensiryou_no $row[gensiryou_no]</font><BR>";	// テスト
		}

		$db = null;

		return $row;

	} catch (PDOException $e) {
    	print "エラー!: " . $e->getMessage() . "<br/>";
	    die();
	}
}


//////////////////////////////////////////////////////////////
// 説明：収蔵品ＤＢ検索
// 機能説明：ＤＢから収蔵番号のものを読み出す
// 引数：
//string $syuuzou_no		(I)検索条件 収蔵番号
//////////////////////////////////////////////////////////////
function sch_db_syuuzou_no($syuuzou_no) {

	global $dbUser;
	global $dbPass;
	global $dbHost;
	global $dbName;
	global $dbType;
	global $dbErrorMessage;
	global $nDispListNo;
	global $debugflag;

	$dsn = "$dbType:dbname=$dbName;host=$dbHost;charset=utf8;";
	try {
		$db = new PDO($dsn, $dbUser, $dbPass);
		$db->query('SET NAMES utf8');

		// syuzoudaityouから
		$sql = "SELECT * FROM siryoudaityou WHERE syuuzou_no LIKE ? ";
		$stmt = $db->prepare($sql);
		if ($stmt->execute(array($syuuzou_no)) === FALSE) {
			print "<font color=red> execute FALSE</font><BR>";	// テスト
			$db = null;
			return FALSE;
		}
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		if ($debugflag) {
			print "<font color=red> syuuzou_no $row[syuuzou_no]</font><BR>";	// テスト
		}

		$db = null;

		return $row;

	} catch (PDOException $e) {
    	print "エラー!: " . $e->getMessage() . "<br/>";
	    die();
	}
}


//////////////////////////////////////////////////////////////
// 説明：収蔵品ＤＢ検索
// 機能説明：ＤＢから収蔵数を読み出す
// 引数：
//////////////////////////////////////////////////////////////
function sch_db_count() {

	global $dbUser;
	global $dbPass;
	global $dbHost;
	global $dbName;
	global $dbType;
	global $dbErrorMessage;
	global $nDispListNo;
	global $debugflag;

	$dsn = "$dbType:dbname=$dbName;host=$dbHost;charset=utf8;";
	try {
		$db = new PDO($dsn, $dbUser, $dbPass);
		$db->query('SET NAMES utf8');

		// syuzoudaityouからgensiryou_no
		$sql = "SELECT COUNT(*) FROM siryoudaityou WHERE gensiryou_no!='' ";
		if ($debugflag) {
			print "<font color=red> sql=$sql</font><BR>";	// テスト
		}
		$result = $db->query($sql);
		$all = $result->fetchColumn();
		if ($debugflag) {
			print "<font color=red> all $all</font><BR>";	// テスト
		}

		// syuzoudaityouからsyuuzou_no
		$sql = "SELECT COUNT(*) FROM siryoudaityou WHERE syuuzou_no!='' ";
		if ($debugflag) {
			print "<font color=red> sql=$sql</font><BR>";	// テスト
		}
		$result = $db->query($sql);
		$search = $result->fetchColumn();
		if ($debugflag) {
			print "<font color=red> syuuzou suu $search</font><BR>";	// テスト
		}

		$db = null;

		print "歴史民俗資料 原資料番号".$all."点、 資料番号".$search."点検索できます。<br/>";

	} catch (PDOException $e) {
    	print "エラー!: " . $e->getMessage() . "<br/>";
	}
}
?>
